/* sigaction() and sigset functions for MiNT; placed in the public domain */

#include <errno.h>
#include <mintbind.h>
#include <signal.h>

int
sigdelset(set, signo)
  sigset_t *set;
  int signo;
{
  int idx;
  int pos;

  if ((!set) || (signo >= __NSIG)) {
    errno = EINVAL;
    return -1;
  }
  idx = _SIGSET_INDEX(signo);
  pos = _SIGSET_BITPOS(signo);
  set->__sigset_data[idx] &= ~(sigmask(pos));
  return 0;  
}
